/*****************************************************************************
* Shakespearian Curse Generator -- Based on lists compiled by Jerry Maguire, *
*     English teacher at Center Grove High School in Greenwood, Indiana.     *
* Public domain implementations by Trevor Stone http://trevorstone.org/curse *
*****************************************************************************/
var adjective1 = new Array("artless","bawdy","beslubbering","bootless","brazen",
    "churlish","cockered","clouted","craven","currish","dankish","dissembling",
    "distempered","droning","errant","fawning","fitful","fobbing","froward",
    "frothy","gleeking","gnarling","goatish","gorbellied","greasy","grizzled",
    "haughty","hideous","impertinent","infectious","jaded","jarring","knavish",
    "lewd","loggerheaded","lumpish","mammering","mangled","mewling","paunchy",
    "peevish","pernicious","prating","pribbling","puking","puny","purpled",
    "quailing","queasy","rank","reeky","roguish","roynish","ruttish","saucy",
    "sottish","spleeny","spongy","surly","tottering","unmuzzled","vacant",
    "vain","venomed","villainous","waggish","wanton","warped","wayward","weedy",
    "wenching","whoreson","yeasty");

var adjective2 = new Array("base-court","bat-fowling","beef-witted",
    "beetle-headed","boil-brained","bunched-backed","clapper-clawed",
    "clay-brained", "common-kissing","crook-pated","dismal-dreaming",
    "dizzy-eyed","dog-hearted","dread-bolted","earth-vexing","elf-skinned",
    "empty-hearted","evil-eyed","eye-offending","fat-kidneyed","fen-sucked",
    "flap-mouthed","fly-bitten","folly-fallen","fool-born","full-gorged",
    "guts-griping","half-faced","hasty-witted","heavy-handed","hedge-born",
    "hell-hated","horn-mad","idle-headed","ill-breeding","ill-composed",
    "ill-nurtured","iron-witted","knotty-pated","lean-witted","lily-livered",
    "mad-bread","milk-livered","motley-minded","muddy-mettled","onion-eyed",
    "pale-hearted","paper-faced","pinch-spotted","plume-plucked",
    "pottle-deep","pox-marked","raw-boned","reeling-ripe","rough-hewn",
    "rude-growing","rug-headed","rump-fed","shag-eared","shard-borne",
    "sheep-biting","shrill-gorged","spur-galled","sour-faced",
    "swag-bellied","tardy-gaited","tickle-brained","toad-spotted",
    "unchin-snouted","weak-hinged","weather-bitten","white-livered");

var noun = new Array("apple-john","baggage","barnacle","bladder","boar-pig",
    "bugbear","bum-bailey","canker-blossom","clack-dish","clotpole","coxcomb",
    "codpiece","crutch","cutpurse","death-token","dewberry","dogfish",
    "egg-shell","flap-dragon","flax-wench","flirt-gill","foot-licker",
    "fustilarian","giglet","gudgeon","gull-catcher","haggard","harpy",
    "hedge-pig","hempseed","hedge-pig","horn-beast","hugger-mugger",
    "jack-a-nape","jolthead","lewdster","lout","maggot-pie","malignancy",
    "malkin","malt-worm","mammet","manikin","measle","minimus","minnow",
    "miscreant","moldwarp","mumble-news","nut-hook","pantaloon","pigeon-egg",
    "pignut","puttock","pumpion","rabbit-sucker","rampallion","ratsbane",
    "remnant","rudesby","ruffian","scantling","scullion","scut","skainsmate",
    "snipe","strumpet","varlot","vassal","waterfly","whey-face","whipster",
    "wagtail","younker");

// backside flip code from Apple's "Dashboard Programming Topics" reference
var gDoneButton;
var gInfoButton;

function setup() {
     gDoneButton = new AppleGlassButton(document.getElementById("doneButton"),
         "Done", hidePrefs);
     gInfoButton = new AppleInfoButton(document.getElementById("infoButton"),
         document.getElementById("front"), "white", "white", showPrefs);
}

function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }
    front.style.display="none";
    back.style.display="block";
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);  
    }
}

function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }
    back.style.display="none";
    front.style.display="block";
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

// return a random element from an array
function randArray(array) {
    return array[Math.floor(Math.random() * array.length)];
}

// generate one curse
function curse1() {
    return "Thou " + randArray(adjective1) + " " + randArray(adjective2)
        + " " + randArray(noun) + "!";
}

// generate many curses
function curse(n, object, property) {
    var result = "";
    while (n-- > 0) {
        result += curse1() + "<br>";
    }
    object[property] = result;
}

// output curses (4 fit in Apple Chancery)
function doCurse() {
    curse(4, document.getElementById("curse"), "innerHTML");
}

// interact with system clipboard
function doCopy(evt) {
    evt.clipboardData.setData("text/html",
        document.getElementById("curse").innerHTML);
}

function doCut(evt) {
    evt.clipboardData.setData("text/html",
        document.getElementById("curse").innerHTML);
    doCurse();
}

// when the user activates the dashboard, generate new curses
if (window.widget) {
    widget.onshow = doCurse;
}
